/* -*- C++ -*- */
// Handle_Timeout.h,v 4.3 1998/10/20 02:34:50 levine Exp

/* Handles timeouts. */

#ifndef _HANDLE_TIMEOUT_H
#define _HANDLE_TIMEOUT_H

#include "ace/Service_Config.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "ace/Service_Types.h"

class Handle_Timeout : public ACE_Service_Object
{
public:
  Handle_Timeout (void);
  virtual int init (int argc, char *argv[]);
  virtual int info (char **, size_t) const;
  virtual int fini (void);

private:
  virtual int get_handle (void) const;
  virtual int handle_timeout (const ACE_Time_Value &tv, const void *arg);

  int count;
};

extern ACE_Service_Object_Type t1;

#if defined (__ACE_INLINE__)
#define ACE_INLINE inline
#include "Handle_Timeout.i"
#else
#define ACE_INLINE
#endif /* __ACE_INLINE__ */

#endif /* _HANDLE_TIMEOUT_H */
